obj = selection[1]
chamferAmount = 1
chamferAngle = 0.85

selEdges = #()
edges = polyop.getNumEdges obj
for i=1 to edges do
(
	faces = polyop.getEdgeFaces obj i
	if (faces.count > 1) then
	(
		n1 = polyop.getFaceNormal obj faces[1]
		n2 = polyop.getFaceNormal obj faces[2]
		
		flatness = (dot n1 n2)
		if flatness < 0 then flatness = 0

		if (flatness < chamferAngle) then append selEdges i
	)
)

origPolys = polyop.getNumFaces obj
polyop.chamferEdges obj selEdges chamferAmount

origPolysV = #()
origPolysVN = #()
for i=1 to origPolys do
(
	n = polyop.getFaceNormal obj i
	v = polyop.getFaceVerts obj i
	for ve=1 to v.count do
	(
		append origPolysV v[ve]
		append origPolysVN n
	)
)
allVerts = #()
allPolys = #()
verts = polyop.getNumVerts obj
polys = polyop.getNumFaces obj
for i=1 to verts do append allVerts i
for i=1 to polys do append allPolys i

polyop.setFaceSmoothGroup obj allPolys 1

nmod = Edit_Normals()
nmod.displayLength = 0
addModifier obj nmod ui:on
max modify mode
modPanel.setCurrentObject $.modifiers[#Edit_Normals]
nmod.makeExplicit selection:(allVerts as bitArray)
my_normals = #{}
for ve=1 to origPolysV.count do
(
	my_verts = #{origPolysV[ve]}
	nmod.ConvertVertexSelection &my_verts &my_normals
	if (my_normals as array).count>0 then
	(
		nmod.setNormal ((my_normals as array)[1]) (origPolysVN[ve])
	)
)

update obj

